package sinhala_converter_v3_0;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.File;
import java.io.RandomAccessFile;

/**
 * <p>Title: Sinhala Converter</p>
 * <p>Description: Convert Sinhala text docs to Unicode</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: UCSC - LTRL</p>
 * @author Viraj Welgama
 * @version 3.0
 */

public class SinConV3Frame extends JFrame {

  JPanel contentPane;

  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabelTop = new JLabel();
  JLabel jLabelWest = new JLabel();
  JLabel jLabelBottom = new JLabel();
  JLabel jLabelEast = new JLabel();
  JPanel jPanelMiddle = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel jLabelMiddleTop = new JLabel();
  JTabbedPane Center = new JTabbedPane();
  JPanel step1 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel Step1_1 = new JPanel();
  JPanel Step1_2 = new JPanel();
  JPanel Step1_3 = new JPanel();
  JPanel Step1_4 = new JPanel();
  JPanel Step1_5 = new JPanel();
  JPanel Step1_6 = new JPanel();
  JPanel Step1_7 = new JPanel();
  JPanel Step1_8 = new JPanel();
  GridLayout gridLayout2 = new GridLayout();
  JLabel jLabelOpenDetail = new JLabel();
  JButton jButton_Open = new JButton();
  GridLayout gridLayout3 = new GridLayout();
  JLabel jLabelInputPath = new JLabel();
  JButton jButtonChange = new JButton();
  GridLayout gridLayout5 = new GridLayout();
  JLabel jLabelOutputPath = new JLabel();
  FlowLayout flowLayout3 = new FlowLayout();
  JButton jButton_Step1_Exit = new JButton();
  JButton jButton_Step1_Next = new JButton();

  JPanel Step2 = new JPanel();
  GridLayout gridLayout6 = new GridLayout();
  JPanel Step2_1 = new JPanel();
  JPanel Step2_2 = new JPanel();
  JPanel Step2_3 = new JPanel();
  JPanel Step2_4 = new JPanel();
  JPanel Step2_5 = new JPanel();
  JPanel Step2_6 = new JPanel();
  JPanel Step2_7 = new JPanel();
  JPanel Step2_8 = new JPanel();
  FlowLayout flowLayout4 = new FlowLayout();
  JButton jButton_Step2_Exit = new JButton();
  JButton jButton_Step2_Next = new JButton();
  JButton jButton_Step2_Back = new JButton();
  GridLayout gridLayout7 = new GridLayout();
  JLabel jLabel_Step2_Head = new JLabel();
  GridLayout gridLayout8 = new GridLayout();
  JLabel jLabel_Step2_list = new JLabel();
  JPanel jPanel_Step2_3_Left = new JPanel();
  JComboBox jComboBoxFontList = new JComboBox();
  GridLayout gridLayout9 = new GridLayout();
  JPanel jPanel_Step2_5_Left = new JPanel();
  FlowLayout flowLayout5 = new FlowLayout();

  JPanel Step3 = new JPanel();
  GridLayout gridLayout10 = new GridLayout();
  JPanel Step3_1 = new JPanel();
  JPanel Step3_2 = new JPanel();
  JPanel Step3_3 = new JPanel();
  JPanel Step3_4 = new JPanel();
  JPanel Step3_5 = new JPanel();
  JPanel Step3_6 = new JPanel();
  JPanel Step3_7 = new JPanel();
  JPanel Step3_8 = new JPanel();
  GridLayout gridLayout11 = new GridLayout();
  JLabel jLabel_Step3_1_Left = new JLabel();
  JLabel jLabel_Step3_1_Right = new JLabel();
  JLabel jLabel_Step3_2_Left = new JLabel();
  JLabel jLabel_Step3_2_Right = new JLabel();
  JLabel jLabel_Step3_3_Left = new JLabel();
  JLabel jLabel_Step3_3_Right = new JLabel();
  GridLayout gridLayout14 = new GridLayout();
  JPanel Step3_5_Top = new JPanel();
  JPanel Step3_5_Bottom = new JPanel();
  Border border1;
  GridLayout gridLayout15 = new GridLayout();
  JProgressBar jProgressBar1 = new JProgressBar(0, 14);
  GridLayout gridLayout16 = new GridLayout();
  JLabel jLabel_Step3_5_Top = new JLabel();
  FlowLayout flowLayout6 = new FlowLayout();
  JButton jButton_Step3_Exit = new JButton();
  JButton jButton_Convert = new JButton();
  JButton jButton_Abort = new JButton();
  JButton jButton_Step3_Back = new JButton();

  JFileChooser jf = new JFileChooser();
    String InputPath = "";
    String OutputPath = "";
    String OutputPathforReader = "";
    String FontName = "";
    String selectFont = "";
    Thread task;
    File LookupDir;
    File inputFiles[];
    String FontList[];
    RandomAccessFile raf;

  Border border2;
  TitledBorder titledBorder1;
  Border border3;
  TitledBorder titledBorder2;
  JPanel jPanel_Step1_1_Right = new JPanel();
  FlowLayout flowLayout7 = new FlowLayout();
  GridLayout gridLayout19 = new GridLayout();
  JPanel Step1_3_Top = new JPanel();
  JPanel Step1_3_Bottom = new JPanel();
  GridLayout gridLayout20 = new GridLayout();
  JLabel jLabelSaveDetail1 = new JLabel();
  GridLayout gridLayout21 = new GridLayout();
  JLabel jLabelSaveDetail2 = new JLabel();
  GridLayout gridLayout4 = new GridLayout();
  GridLayout gridLayout17 = new GridLayout();
  JLabel jLabel_Step1_4_Left = new JLabel();
  JPanel Step1_4_Right = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton jButton_View = new JButton();
  GridLayout gridLayout18 = new GridLayout();
  JPanel Step3_6_Top = new JPanel();
  GridLayout gridLayout22 = new GridLayout();
  JLabel Step3_6_Top_Lable = new JLabel();
  GridLayout gridLayout13 = new GridLayout();
  JLabel Step3_1_Label = new JLabel();
  GridLayout gridLayout12 = new GridLayout();
  JPanel Step3_2_Top = new JPanel();
  JPanel Step3_2_Bottom = new JPanel();
  JLabel Step3_2_Top_Label = new JLabel();
  FlowLayout flowLayout2 = new FlowLayout();
  JPanel Step3_3_Top = new JPanel();
  JPanel Step3_3_Bottom = new JPanel();
  FlowLayout flowLayout8 = new FlowLayout();
  FlowLayout flowLayout9 = new FlowLayout();
  FlowLayout flowLayout10 = new FlowLayout();

  //Construct the frame
  public SinConV3Frame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    border2 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    titledBorder1 = new TitledBorder(border2,"Opened path");
    border3 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    titledBorder2 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)),"To be saved in...");
    jLabelTop.setIcon(new ImageIcon(SinConV3Frame.class.getResource("header.jpg")));
    jLabelTop.setText("         ");
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(481, 511));
    this.setTitle("Sinhala Converter V3.0");
    jLabelWest.setText("        ");
    jLabelBottom.setIcon(new ImageIcon(SinConV3Frame.class.getResource("Footer.jpg")));
    jLabelBottom.setText(" ");
    jLabelEast.setText("        ");
    jPanelMiddle.setLayout(borderLayout2);
    jLabelMiddleTop.setText("  ");
    step1.setLayout(gridLayout1);
    gridLayout1.setRows(8);
    Step1_1.setLayout(gridLayout2);
    jLabelOpenDetail.setText("Select source file(s) using \"Open\" Buttton");
    Step1_2.setLayout(gridLayout19);
    jButton_Open.setText("Open");
    jButton_Open.addActionListener(new SinConV3Frame_jButton_Open_actionAdapter(this));
    Step1_3.setLayout(gridLayout3);
    jLabelInputPath.setBorder(titledBorder1);
    jLabelInputPath.setText("");
    Step1_4.setLayout(gridLayout17);
    Step1_5.setLayout(gridLayout4);
    jButtonChange.setEnabled(false);
    jButtonChange.setText("Change");
    jButtonChange.addActionListener(new SinConV3Frame_jButtonChange_actionAdapter(this));
    Step1_6.setLayout(gridLayout5);
    jLabelOutputPath.setBorder(titledBorder2);
    jLabelOutputPath.setRequestFocusEnabled(true);
    jLabelOutputPath.setText("");
    Step1_7.setBackground(SystemColor.inactiveCaptionBorder);
    Step1_7.setForeground(Color.black);
    Step1_7.setLayout(flowLayout3);
    flowLayout3.setAlignment(FlowLayout.RIGHT);
    jButton_Step1_Exit.setText("Exit");
    jButton_Step1_Exit.addActionListener(new SinConV3Frame_jButton_Step1_Exit_actionAdapter(this));
    jButton_Step1_Next.setEnabled(false);
    jButton_Step1_Next.setText("Next >>");
    jButton_Step1_Next.addActionListener(new SinConV3Frame_jButton_Step1_Next_actionAdapter(this));
    Step2.setLayout(gridLayout6);
    gridLayout6.setRows(8);
    Step2_7.setBackground(SystemColor.inactiveCaptionBorder);
    Step2_7.setLayout(flowLayout4);
    flowLayout4.setAlignment(FlowLayout.RIGHT);
    jButton_Step2_Exit.setText("Exit");
    jButton_Step2_Exit.addActionListener(new SinConV3Frame_jButton_Step2_Exit_actionAdapter(this));
    jButton_Step2_Next.setEnabled(false);
    jButton_Step2_Next.setText("Next >>");
    jButton_Step2_Next.addActionListener(new SinConV3Frame_jButton_Step2_Next_actionAdapter(this));
    jButton_Step2_Back.setText("<< Back");
    jButton_Step2_Back.addActionListener(new SinConV3Frame_jButton_Step2_Back_actionAdapter(this));
    Step2_1.setLayout(gridLayout7);
    jLabel_Step2_Head.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel_Step2_Head.setRequestFocusEnabled(true);
    jLabel_Step2_Head.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel_Step2_Head.setText("Collecting information about the input file(s)");
    Step2_3.setLayout(gridLayout8);
    jLabel_Step2_list.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel_Step2_list.setText("Select the source font form the list : ");
    jComboBoxFontList.addActionListener(new SinConV3Frame_jComboBoxFontList_actionAdapter(this));
    Step2_5.setLayout(gridLayout9);
    jPanel_Step2_5_Left.setLayout(flowLayout5);
    Center.setTabPlacement(JTabbedPane.TOP);
    jPanel_Step1_1_Right.setLayout(flowLayout7);
    gridLayout3.setRows(2);
    Step1_3_Top.setLayout(gridLayout20);
    jLabelSaveDetail1.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabelSaveDetail1.setText("");
    Step1_3_Bottom.setLayout(gridLayout21);
    jLabelSaveDetail2.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabelSaveDetail2.setText("");
    Step1_4_Right.setLayout(flowLayout1);
    jButton_Abort.setEnabled(false);
    jButton_Abort.addActionListener(new SinConV3Frame_jButton_Abort_actionAdapter(this));
    jButton_Convert.addActionListener(new SinConV3Frame_jButton_Convert_actionAdapter(this));
    jButton_View.setEnabled(false);
    jButton_View.setText("View");
    jButton_View.addActionListener(new SinConV3Frame_jButton_View_actionAdapter(this));
    Step3_6.setLayout(gridLayout18);
    gridLayout18.setRows(2);
    Step3_6_Top.setLayout(gridLayout22);
    Step3.setLayout(gridLayout10);
    gridLayout10.setRows(8);
    Step3_7.setBackground(SystemColor.activeCaptionBorder);
    Step3_7.setLayout(flowLayout6);
    Step3_5.setLayout(gridLayout14);
    Step3_1.setLayout(gridLayout11);
    jLabel_Step3_1_Left.setHorizontalAlignment(SwingConstants.LEFT);
    jLabel_Step3_1_Left.setText("Number of files selected :  ");
    Step3_2.setLayout(gridLayout12);
    jLabel_Step3_2_Left.setHorizontalAlignment(SwingConstants.LEFT);
    jLabel_Step3_2_Left.setText("Source file(s) font :  ");
    Step3_3.setLayout(gridLayout13);
    jLabel_Step3_3_Left.setHorizontalAlignment(SwingConstants.LEFT);
    jLabel_Step3_3_Left.setText("To be saved in :  ");
    gridLayout14.setRows(2);
    Step3_5_Bottom.setBorder(border1);
    Step3_5_Bottom.setLayout(gridLayout15);
    Step3_5_Top.setLayout(gridLayout16);
    jLabel_Step3_5_Top.setText("");
    flowLayout6.setAlignment(FlowLayout.RIGHT);
    jButton_Step3_Exit.setText("Exit");
    jButton_Step3_Exit.addActionListener(new SinConV3Frame_jButton_Step3_Exit_actionAdapter(this));
    jButton_Convert.setText("Convert");
    jButton_Abort.setText("Abort");
    jButton_Step3_Back.setText("<< Back");
    jButton_Step3_Back.addActionListener(new SinConV3Frame_jButton_Step3_Back_actionAdapter(this));
    Step3_1_Label.setFont(new java.awt.Font("Dialog", 0, 12));
    Step3_1_Label.setHorizontalAlignment(SwingConstants.CENTER);
    Step3_1_Label.setText("Input file(s) are ready to convert. Click \"Convert\" to proceed");
    gridLayout12.setRows(2);
    Step3_2_Top.setLayout(flowLayout10);
    Step3_2_Top_Label.setFont(new java.awt.Font("Dialog", 1, 11));
    Step3_2_Top_Label.setText("Final Convert Settings");
    Step3_2_Bottom.setLayout(flowLayout2);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    gridLayout13.setRows(2);
    Step3_3_Top.setLayout(flowLayout8);
    flowLayout8.setAlignment(FlowLayout.LEFT);
    Step3_3_Bottom.setLayout(flowLayout9);
    flowLayout9.setAlignment(FlowLayout.LEFT);
    jLabel_Step3_1_Right.setText("");
    jLabel_Step3_2_Right.setText("");
    jLabel_Step3_3_Right.setText("");
    flowLayout10.setAlignment(FlowLayout.LEFT);
    Step3_7.add(jButton_Step3_Back, null);
    Step3_7.add(jButton_View, null);
    Step3_7.add(jButton_Abort, null);
    Step3_7.add(jButton_Convert, null);
    Step2_7.add(jButton_Step2_Back, null);
    Step2_7.add(jButton_Step2_Next, null);
    Step1_7.add(jButton_Step1_Next, null);
    contentPane.add(jLabelTop, BorderLayout.NORTH);
    contentPane.add(jLabelWest, BorderLayout.WEST);
    contentPane.add(jLabelBottom, BorderLayout.SOUTH);
    contentPane.add(jLabelEast, BorderLayout.EAST);
    contentPane.add(jPanelMiddle, BorderLayout.CENTER);
    jPanelMiddle.add(jLabelMiddleTop, BorderLayout.NORTH);
    jPanelMiddle.add(Center, BorderLayout.CENTER);
    Center.add(step1,    "Step 1");
    step1.add(Step1_1, null);
    step1.add(Step1_2, null);
    Step1_2.add(jLabelInputPath, null);
    step1.add(Step1_3, null);
    Step1_3.add(Step1_3_Top, null);
    step1.add(Step1_4, null);
    Step1_4.add(jLabel_Step1_4_Left, null);
    Step1_4.add(Step1_4_Right, null);
    Step1_4_Right.add(jButtonChange, null);
    step1.add(Step1_5, null);
    Step1_5.add(jLabelOutputPath, null);
    Step1_1.add(jLabelOpenDetail, null);
    Step1_1.add(jPanel_Step1_1_Right, null);
    jPanel_Step1_1_Right.add(jButton_Open, null);
    step1.add(Step1_6, null);
    step1.add(Step1_7, null);
    step1.add(Step1_8, null);
    Step1_7.add(jButton_Step1_Exit, null);
    Center.add(Step2,  "Step 2");
    Step2.add(Step2_1, null);
    Step2.add(Step2_2, null);
    Step2.add(Step2_3, null);
    Step2.add(Step2_4, null);
    Step2.add(Step2_5, null);
    Step2.add(Step2_6, null);
    Step2.add(Step2_7, null);
    Step2.add(Step2_8, null);
    Center.add(Step3,  "Step 3");
    Step2_7.add(jButton_Step2_Exit, null);
    Step2_1.add(jLabel_Step2_Head, null);
    Step2_3.add(jLabel_Step2_list, null);
    Step2_3.add(jPanel_Step2_3_Left, null);
    jPanel_Step2_3_Left.add(jComboBoxFontList, null);
    Step2_5.add(jPanel_Step2_5_Left, null);
    Step3.add(Step3_1, null);
    Step3_1.add(Step3_1_Label, null);
    Step3.add(Step3_2, null);
    Step3.add(Step3_3, null);
    Step3.add(Step3_4, null);
    Step3.add(Step3_5, null);
    Step3_5.add(Step3_5_Top, null);
    Step3.add(Step3_6, null);
    Step3_6.add(Step3_6_Top, null);
    Step3.add(Step3_7, null);
    Step3.add(Step3_8, null);
    Step3_5.add(Step3_5_Bottom, null);
    Step3_5_Bottom.add(jProgressBar1, null);
    Step3_5_Top.add(jLabel_Step3_5_Top, null);
    Step3_7.add(jButton_Step3_Exit, null);
    Step1_3.add(Step1_3_Bottom, null);
    Step1_3_Top.add(jLabelSaveDetail1, null);
    Step1_3_Bottom.add(jLabelSaveDetail2, null);
    Step3_6_Top.add(Step3_6_Top_Lable, null);
    Step3_2.add(Step3_2_Top, null);
    Step3_2.add(Step3_2_Bottom, null);
    Step3_2_Bottom.add(jLabel_Step3_1_Left, null);
    Step3_2_Bottom.add(jLabel_Step3_1_Right, null);
    Step3_2_Top.add(Step3_2_Top_Label, null);
    Step3_3.add(Step3_3_Top, null);
    Step3_3_Top.add(jLabel_Step3_2_Left, null);
    Step3_3_Top.add(jLabel_Step3_2_Right, null);
    Step3_3.add(Step3_3_Bottom, null);
    Step3_3_Bottom.add(jLabel_Step3_3_Left, null);
    Step3_3_Bottom.add(jLabel_Step3_3_Right, null);
    Center.setEnabledAt(1, false);
    Center.setEnabledAt(2, false);
    jProgressBar1.setValue(0);

    //Add lookup tables for the list
    LookupDir = new File(".\\Resources\\");
    FontList = LookupDir.list();
    jComboBoxFontList.addItem("");
    for (int i = 0; i < FontList.length; i++)
      jComboBoxFontList.addItem(FontList[i].substring(0,
          FontList[i].length() - 4));

  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public void delete() {
    try {
      raf.close();
      new File(OutputPath).delete();
      jButton_Abort.setEnabled(false);
    }//try
    catch (java.io.IOException io) {
    }//catch
  } //delete

  void jButton_Step1_Next_actionPerformed(ActionEvent e) {
   Center.setEnabledAt(0, false);
   Center.setEnabledAt(1, true);
   Center.setSelectedComponent(Step2);
  }

  void jButton_Step1_Exit_actionPerformed(ActionEvent e) {
    System.exit(1000);
  }

  void jButton_Step2_Back_actionPerformed(ActionEvent e) {
    Center.setEnabledAt(1, false);
    Center.setEnabledAt(0, true);
    Center.setSelectedComponent(step1);
  }

  void jButton_Step2_Next_actionPerformed(ActionEvent e) {
    Center.setEnabledAt(1, false);
    Center.setEnabledAt(2, true);
    Center.setSelectedComponent(Step3);
    jLabel_Step3_1_Right.setText(Integer.toString(inputFiles.length));
    jLabel_Step3_2_Right.setText(jComboBoxFontList.getSelectedItem().toString());
     jLabel_Step3_3_Right.setText(OutputPath);
  }

  void jButton_Step2_Exit_actionPerformed(ActionEvent e) {
    System.exit(1000);
  }

  void jButton_Step3_Back_actionPerformed(ActionEvent e) {
    Center.setEnabledAt(2, false);
    Center.setEnabledAt(1, true);
    Center.setSelectedComponent(Step2);
  }

  void jButton_Step3_Exit_actionPerformed(ActionEvent e) {
    System.exit(1000);
  }

  void jButton_Open_actionPerformed(ActionEvent e) {

    jf.setFileFilter(new TextFileFilter());
    jf.setMultiSelectionEnabled(true);
    jf.setFileSelectionMode(jf.FILES_ONLY);

    if (jf.showOpenDialog(this) == jf.APPROVE_OPTION) {
      inputFiles = jf.getSelectedFiles();

      if (inputFiles.length == 1)
        jLabelInputPath.setText(inputFiles[0].getAbsolutePath());
      else
        jLabelInputPath.setText(inputFiles[0].getParent() + " - " +
                                inputFiles.length + " files.");

      OutputPath = inputFiles[0].getParent();
      jLabelOutputPath.setText(OutputPath);
      jLabelSaveDetail1.setText(
          "Converted file will be saved in the same directory as <FileName>_Unicode.txt");
      jLabelSaveDetail2.setText(
          "You can change the location using \"Change\" button.");
      jButton_Step1_Next.setEnabled(true);
      jButtonChange.setEnabled(true);
      return;

    }
  } ///Button Open

  void jButtonChange_actionPerformed(ActionEvent e) {

    jf.setFileFilter(new DirFilter());
    jf.setFileSelectionMode(jf.DIRECTORIES_ONLY);
    jf.setMultiSelectionEnabled(false);

    if (jf.showSaveDialog(this) == jf.APPROVE_OPTION) {
      OutputPath = jf.getSelectedFile().getAbsolutePath();
      jLabelOutputPath.setText(OutputPath);
    }

  }

  void jComboBoxFontList_actionPerformed(ActionEvent e) {
    if(jComboBoxFontList.getSelectedItem().toString().equals(""))
      jButton_Step2_Next.setEnabled(false);
      else {
      jButton_Step2_Next.setEnabled(true);
      selectFont = jComboBoxFontList.getSelectedItem().toString();
      FontName = selectFont.concat(".res");
      FontName = ".//Resources//".concat(FontName);
      }
  }

  void jButton_Convert_actionPerformed(ActionEvent e) {

    if (jButton_Convert.getText().equals("Convert")) {

      jButton_Step3_Back.setEnabled(false);
      jButton_Abort.setEnabled(true);

      task = new Thread() {
        public void run() {
          InitialReader in = new InitialReader();
          InitialReaderGr ing = new InitialReaderGr();
          int counter = 0;
          String display = "";
          for(int i = 0; i<inputFiles.length; i++) {
            display = i+1 + "/" + inputFiles.length + " - Converting...";
            InputPath = inputFiles[i].getAbsolutePath();

            OutputPathforReader = OutputPath + "\\" +
                inputFiles[i].getName().
                substring(0,
                inputFiles[i].getName().length() - 4).concat("_Unicode.txt");

          try {
            File f = new File(OutputPathforReader);
            if(f.exists())
              f.delete();
            raf = new RandomAccessFile(OutputPathforReader, "rw");
          }
          catch (java.io.FileNotFoundException fnf) {}

          jLabel_Step3_5_Top.setText(display);
          Step3_6_Top_Lable.setText(InputPath);

          if (FontName.endsWith("GaramondSNTM.res"))
            ing = new InitialReaderGr(InputPath, FontName,
                OutputPathforReader,
                jProgressBar1,
                raf);

          else {
            in = new InitialReader(InputPath, FontName,
                OutputPathforReader,
                jProgressBar1,
                raf);
          }
          if (in.printMassage().startsWith("java.")) {

            if (in.printMassage().endsWith("memory.")) {
              JOptionPane.showMessageDialog(new SinConV3Frame(),
                                            in.printMassage(),
                                            "Sinhala Converter V3 - Error!",
                                            JOptionPane.ERROR_MESSAGE);
              delete();
            }
            else {
              JOptionPane.showMessageDialog(new SinConV3Frame(),
                                            "Lookup table for " +
                                            selectFont +
                                            " is missing!",
                                            "Sinhala Converter V3 - Error!",
                                            JOptionPane.ERROR_MESSAGE);
              delete();

            }
          }
          else
          if (in.printMassage().endsWith("Internal Error")) {
            JOptionPane.showMessageDialog(new SinConV3Frame(),
                                          in.printMassage(),
                                          "Sinhala Converter V3 - Error!",
                                          JOptionPane.ERROR_MESSAGE);
            delete();
          }
          else
          if (in.printMassage().endsWith("word")) {
            JOptionPane.showMessageDialog(new SinConV3Frame(),
                                          in.printMassage(),
                                          "Sinhala Converter V3 - Error!",
                                          JOptionPane.ERROR_MESSAGE);
            delete();
          }
          else
            counter++;
          jProgressBar1.setValue(0);
          jLabel_Step3_5_Top.setText("");
          Step3_6_Top_Lable.setText("");
        }//for

        String mag = counter + " out of " + inputFiles.length + " file(s) are successfuly converterd.";
            JOptionPane.showMessageDialog(new SinConV3Frame(),
                                          mag,
                                          "Sinhala Converter V3",
                                          JOptionPane.INFORMATION_MESSAGE);
            jButton_Abort.setEnabled(false);
            jButton_Convert.setText("Finish");
            if(counter>0) jButton_View.setEnabled(true);

        } // run
      }; //Thread task1

      task.start();
    }
    else {
      OutputPath = "";
      inputFiles = null;
      jLabelInputPath.setText("");
      jLabelOutputPath.setText("");
      jProgressBar1.setValue(0);
      jLabel_Step3_5_Top.setText("");
      Step3_6_Top_Lable.setText("");
      jLabelSaveDetail1.setText("");
      jLabelSaveDetail2.setText("");
      jButton_Convert.setText("Convert");
      jButton_Step3_Back.setEnabled(true);
      jButton_View.setEnabled(false);
      jButton_Step1_Next.setEnabled(false);
      jButtonChange.setEnabled(false);
      Center.setEnabledAt(1, false);
      Center.setEnabledAt(2, false);
      Center.setEnabledAt(0, true);
      Center.setSelectedComponent(step1);
    }

  }

  void jButton_View_actionPerformed(ActionEvent e) {
    try {
      for (int i = 0; i < inputFiles.length; i++) {
        String open = "notepad.exe ".concat(OutputPath + "\\" +
                inputFiles[i].getName().
                substring(0,
                inputFiles[i].getName().length() - 4).concat("_Unicode.txt"));
        Runtime.getRuntime().exec(open);
      }
    }
    catch (java.io.IOException ioe) {
      JOptionPane.showMessageDialog(new SinConV3Frame(),
                                    "Sorry! Output file missing.",
                                    "Sinhala Converter V3 - Error!",
                                    JOptionPane.ERROR_MESSAGE);
    }

  }

  void jButton_Abort_actionPerformed(ActionEvent e) {
    if (task.isAlive())
      task.suspend();
    int k = JOptionPane.showConfirmDialog(this,
        "This will abort the converting process. "
        + "\nDo you want to abort?",
        "Sinhala Converter V3 - ",
        JOptionPane.YES_NO_OPTION);

    if (k == JOptionPane.NO_OPTION) {
      task.resume();
    }
    if (k == JOptionPane.YES_OPTION) {
      task.stop();
      JOptionPane.showMessageDialog(this,
                                    "Converting process aborted by user !",
                                    "Sinhala Converter V3 - Worning", JOptionPane.WARNING_MESSAGE);

      jButton_Convert.setText("Finish");
      jButton_Abort.setEnabled(false);
    }
  }

}

class SinConV3Frame_jComboBoxFontList_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jComboBoxFontList_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jComboBoxFontList_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step1_Next_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step1_Next_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step1_Next_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step1_Exit_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step1_Exit_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step1_Exit_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step2_Back_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step2_Back_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step2_Back_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step2_Next_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step2_Next_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step2_Next_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step2_Exit_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step2_Exit_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step2_Exit_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step3_Back_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step3_Back_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step3_Back_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Step3_Exit_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Step3_Exit_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Step3_Exit_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Open_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Open_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Open_actionPerformed(e);
  }
}

class SinConV3Frame_jButtonChange_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButtonChange_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonChange_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Convert_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Convert_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Convert_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_View_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_View_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_View_actionPerformed(e);
  }
}

class SinConV3Frame_jButton_Abort_actionAdapter implements java.awt.event.ActionListener {
  SinConV3Frame adaptee;

  SinConV3Frame_jButton_Abort_actionAdapter(SinConV3Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Abort_actionPerformed(e);
  }
}