package sinhala_converter_v3_0;

import javax.swing.UIManager;
import java.awt.*;

/**
 * <p>Title: Sinhala Converter</p>
 * <p>Description: Convert Sinhala text docs to Unicode</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: UCSC - LTRL</p>
 * @author Viraj Welgama
 * @version 3.0
 */

public class SinConverter {
  boolean packFrame = false;

  //Construct the application
  public SinConverter() {
    SinConV3Frame frame = new SinConV3Frame();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }
  //Main method
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new SinConverter();
  }
}